import java.util.*;
import java.text.*;

class Usuario{
  // Atributos privados.
  public String nome;
  private String login;
  private Date dataCriacao;
  // Atributos publicos
  // Acontecimentos para mostrar na timeline
  // Ideia: criar um ArrayList que aceita qualquer tipo e sempre que ocorrer alguma notificação (pensamento, comentario, like ou dislike), colocar nessa ArrayList
  // Outra ideia que é melhor:
  //    criar um objeto Timeline dentro de Usuario (ou Pessoa)
  //    esse objeto timeline seria um Array de Strings, e cada uma dessas strings é um acontecimento das pessoas relacionadas
  //    por exemplo, p1 é amiga de p2 e p3:
  //      >p2 curtiu o comentario de p3
  //      >p2 publicou um pensamento
  //      >p3 comentou no pensamento de p2
  //    então o Array da timeline de p1 ficaria assim:
  //      [0]: p2 curtiu o comentario (string do comentario) de p3
  //      [1]: p2 publicou o pensamento (string do pensamento)
  //      [2]: p3 comentou (string do comentario) na publicação (string da publicação) de p2
  //    sempre que uma pessoa p1 chama um metodo de algum acontecimento (pensamento, comentario, like ou dislike)
  //    as pessoas com a quel ela é relacionada serão notificadas do acontecimento por meio de uma string que será
  //    colocada no campo timeline das pessoas relacionadas com p1.
  protected ArrayList <Pensamento> pensamentos;
  protected ArrayList <Comentario> comentarios;
  protected ArrayList <Like> likes;
  protected ArrayList <Dislike> dislikes;
  protected ArrayList <String> timeline;
  protected ArrayList <String> publicacoes;

  // Seters.
  protected void setNome(String novoNome){
    this.nome = novoNome;
  }
  protected void setLogin(String novoLogin){
    this.login = novoLogin;
  }
  protected void setDataCriacao(){
    this.dataCriacao = new Date();
  }

  // Geters
  public String getNome(){
    return(this.nome);
  }
  public String getLogin(){
    return(this.login);
  }
  public Date getDataCriacao(){
    return(this.dataCriacao);
  }
  public Pensamento getPensamento(int indice){
    return(this.pensamentos.get(indice));
  }
  public int getIndicePensamento(Pensamento pensamentoProcurado){
    return(this.pensamentos.indexOf(pensamentoProcurado));
  }
  public Comentario getComentario(int indice){
    return(this.comentarios.get(indice));
  }
  public int getIndiceComentario(Comentario comentarioProcurado){
    return(this.comentarios.indexOf(comentarioProcurado));
  }
  public Like getLike(int indice){
    return(this.likes.get(indice));
  }
  public int getIndiceLike(Pensamento likeProcurado){
    return(this.likes.indexOf(likeProcurado));
  }
  public Dislike getDislike(int indice){
    return(this.dislikes.get(indice));
  }
  public int getIndiceDislike(Pensamento dislikeProcurado){
    return(this.dislikes.indexOf(dislikeProcurado));
  }
}
